"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _beeDatepicker = _interopRequireDefault(require("bee-datepicker"));

var _moment = _interopRequireDefault(require("moment"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var dateFormats = ['YYYY-MM-DD', 'DD-MM-YYYY', 'YYYY/MM/DD', 'DD/MM/YYYY', 'YYYY.MM.DD', 'DD.MM.YYYY'];
var __THEMETYPE__ = process.env.__THEMETYPE__;

var DatePickerAdapter = /*#__PURE__*/function (_Component) {
  _inherits(DatePickerAdapter, _Component);

  function DatePickerAdapter(props) {
    var _this;

    _classCallCheck(this, DatePickerAdapter);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DatePickerAdapter).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "onChangeEventAdapter", function (time) {
      var _this$props = _this.props,
          format = _this$props.format,
          onChange = _this$props.onChange;
      var timeString = null;

      if (time !== null) {
        timeString = time.format(format);
      }

      onChange && onChange(time, timeString);
    });

    _defineProperty(_assertThisInitialized(_this), "renderIcon", function () {
      return _react["default"].createElement("i", {
        className: "anticon anticon-star-o"
      });
    });

    var locale = window.cb && cb.lang && cb.lang.langType ? cb.lang.langType.substring(0, 2) : 'zh';

    _moment["default"].locale(locale); // 设置为英文


    var _locale = window.cb && cb.lang ? cb.lang.lang : 'zh_CN';

    _this.locale = require('bee-datepicker/build/locale/' + _locale + '.js');
    return _this;
  }

  _createClass(DatePickerAdapter, [{
    key: "render",
    value: function render() {
      var format = this.props.format; // 日期录入按自己设置的格式录入+去掉分割符的
      // 需要支持4种输入格式（YYYYMMDD）：20191201     2019/12/01     2019.12.01    2019-12-01

      var defaultFormat = dateFormats.includes(format) ? format.replace(/[-|/|.]/g, '') : '';

      var a2tProps = _objectSpread({}, this.props, {
        onChange: this.onChangeEventAdapter,
        // 未指定则传 undefined 使用默认值
        locale: this.locale,
        renderIcon: this.renderIcon,
        format: defaultFormat ? [format].concat(defaultFormat) : format,
        enterKeyDown: __THEMETYPE__ !== 'ys'
      });

      return _react["default"].createElement(_beeDatepicker["default"], _extends({
        showToday: false
      }, a2tProps));
    }
  }]);

  return DatePickerAdapter;
}(_react.Component);

DatePickerAdapter.YearPicker = _beeDatepicker["default"].YearPicker;
var _default = DatePickerAdapter;
exports["default"] = _default;