"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _beeFormControl = _interopRequireDefault(require("bee-form-control"));

var _beeInputGroup = _interopRequireDefault(require("bee-input-group"));

var _TextArea = _interopRequireDefault(require("./TextArea"));

var _Search = _interopRequireDefault(require("./Search"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var sizeMap = {
  small: 'sm',
  large: 'lg',
  "default": 'md'
};
var defaultProps = {
  size: 'default'
};
var propsType = {
  size: _propTypes["default"].string
};

var InputAdapter = /*#__PURE__*/function (_Component) {
  _inherits(InputAdapter, _Component);

  function InputAdapter(props) {
    var _this;

    _classCallCheck(this, InputAdapter);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(InputAdapter).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "focus", function () {
      _this.inputRef.input.focus();
    });

    _defineProperty(_assertThisInitialized(_this), "blur", function () {
      _this.inputRef.input.blur();
    });

    _defineProperty(_assertThisInitialized(_this), "handleKeyDown", function (e) {
      var _this$props = _this.props,
          onPressEnter = _this$props.onPressEnter,
          onKeyDown = _this$props.onKeyDown;

      if (e.keyCode === 13 && onPressEnter) {
        onPressEnter(e);
      }

      if (onKeyDown) {
        onKeyDown(e);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleEvent", function (val, e, propEvent) {
      var fn = _this.props[propEvent];
      fn && fn(e);

      if (propEvent === 'onChange') {
        _this.setState({
          value: val
        });
      }
    });

    _this.state = {
      value: props.value
    };
    return _this;
  }

  _createClass(InputAdapter, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.props.value) {
        this.setState({
          value: nextProps.value
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          defaultValue = _this$props2.defaultValue,
          disabled = _this$props2.disabled,
          size = _this$props2.size,
          placeholder = _this$props2.placeholder,
          addonBefore = _this$props2.addonBefore,
          addonAfter = _this$props2.addonAfter,
          suffix = _this$props2.suffix,
          type = _this$props2.type,
          others = _objectWithoutProperties(_this$props2, ["defaultValue", "disabled", "size", "placeholder", "addonBefore", "addonAfter", "suffix", "type"]);

      var value = this.state.value; // 根据withAdon 来判断是不是需要用 InputGroup

      var withAddon = addonAfter || addonBefore;
      var componentClass = this.props.componentClass;
      componentClass = componentClass || 'input';

      if (type === 'textarea') {
        componentClass = type;
      }

      var formControl = _react["default"].createElement(_beeFormControl["default"], _extends({}, others, {
        type: "text",
        disabled: disabled,
        ref: function ref(e) {
          _this2.inputRef = e;
        },
        placeholder: placeholder,
        value: value === null ? '' : value,
        defaultValue: defaultValue,
        size: sizeMap[size],
        onKeyDown: this.handleKeyDown,
        onChange: function onChange(val, e) {
          _this2.handleEvent(val, e, 'onChange');
        },
        onClick: function onClick(val, e) {
          _this2.handleEvent(val, e, 'onClick');
        },
        onBlur: function onBlur(val, e) {
          _this2.handleEvent(val, e, 'onBlur');
        },
        onFocus: function onFocus(val, e) {
          _this2.handleEvent(val, e, 'onFocus');
        },
        componentClass: componentClass,
        title: value || placeholder
      }));

      if (suffix || withAddon) {
        // 目前 suffix 主要用于处理参照的 icon
        return _react["default"].createElement(_beeInputGroup["default"], {
          simple: !!suffix
        }, withAddon && addonBefore && _react["default"].createElement(_beeInputGroup["default"].Addon, null, addonBefore), formControl, suffix && _react["default"].createElement(_beeInputGroup["default"].Button, {
          shape: "border",
          onClick: function onClick(val, e) {
            _this2.handleEvent(val, e, 'onClick');
          }
        }, suffix), withAddon && addonAfter && _react["default"].createElement(_beeInputGroup["default"].Addon, null, addonAfter));
      }

      return formControl;
    }
  }]);

  return InputAdapter;
}(_react.Component);

InputAdapter.TextArea = _TextArea["default"];
InputAdapter.Search = _Search["default"];
InputAdapter.defaultProps = defaultProps;
InputAdapter.propsType = propsType;
var _default = InputAdapter;
exports["default"] = _default;